data Programa = PROG Comando

data Comando = ATRIB Id Expressao
               | DECL Declaracao Comando
               | WHILE Expressao Comando
               | IF_THEN_ELSE Expressao Comando Comando
               | IO Io
               | SEQ_COMM Comando Comando
               | SKIP sk
               | PROC Id ListaExpressao

type sk = "skip"

data Expressao = LITI Int
               | LITB Bool
               | LITS String

               -- ExpUnaria
               | MINUS Expressao
               | NOT Expressao
               | LENGTH Expressao

               -- ExpBinaria
               | SOMA Expressao Expressao
               | SUBTRACAO Expressao Expressao
               | AND Expressao Expressao
               | OR Expressao Expressao
               | IGUAL Expressao Expressao
               | CONCATENA Expressao Expressao
               | IDENT Id
               | IDENT2 &Id

data Declaracao = VAR_IGUAL Id Expressao
                | PONTEIRO Id Tipo
                | PROC_PAR Id ListaDeclaracaoParametro Comando
                | PROC_VOID Id Comando
                | VIRG Declaracao Declaracao

data ListaDeclaracaoParametro = SINGLE_DECL Tipo Id
                              | LIST_DECL Tipo Id ListaDeclaracaoParametro

type Tipo = String
          | Int
          | Bool

data IO = WRITE Expressao
        | READ Id

data ListaExpressao = FINAL Expressao
                    | LIST_EXP Expressao ListaExpressao

type Id = String

data Valor = V1 Int | V2 Bool | V3 String


-- AQUI COMEA OS EVAL
interprete :: Programa -> Input -> String
interprete (PROG prog) (i) = printMemory (evalComando (prog) memory)

evalComando :: Comando -> Memory -> Memory
evalComando (ATRIB ident expr) (mem) = evalAtribuicao (showId ident) (eval expr) (mem)
evalComando (DECL decl comm) (mem) = evalDeclaracao (eval decl) (evalComando comm) (mem)
evalComando (WHILE expr comm) (mem) = evalWhile (eval expr) (eval comm) (mem)
evalComando (IF_THEN_ELSE expr comm1 comm2) (mem) = evalIfThenElse (eval expr) (eval comm1) (eval comm2) (mem)
evalComando (IO entrada) (mem) = evalIO (eval entrada) (mem)
evalComando (SEQ_COMM comm1 comm2) (mem) = evalSeqComm (eval comm1) (eval comm2) (mem)
evalComando (SKIP sk) (mem) = evalSkip (showId sk) (mem)
evalComando (PROC ident lista) (mem) = evalProcedure (showId ident) (eval lista) (mem)

evalDeclaracao :: Valor ->
evalDeclaracao (VAR_IGUAL a) =
evalDeclaracao (PONTEIRO a) =
evalDeclaracao (PROC_VOID a) =
evalDeclaracao (VIRG a) =

evalWhile :: Expressao -> Comando ->
evalWhile (expr comm) = (eval expr) h...




eval :: Expressao -> Valor
eval (LITI i) = V1 i
eval (LITB b) = V2 b
eval (LITS s) = V3 s
eval (NOT e) = notValor (eval e)
eval (MINUS e) = minusValor (eval e)
eval (LENGTH e) = lenValor (eval e)
eval (SOMA e1 e2) = sumValor (eval e1) (eval e2)
eval (SUBTRACAO e1 e2) = subValor (eval e1) (eval e2)
eval (AND e1 e2) = andValor (eval e1) (eval e2)
eval (OR e1 e2) = orValor (eval e1) (eval e2)
eval (IGUAL e1 e2) = igualValor (eval e1) (eval e2)
eval (CONCATENA e1 e2) = concValor (eval e1) (eval e2)
eval (IDENT i) = showId i
eval (IDENT2 i) = showId i

showValor :: Valor -> String
showValor (V1 i) = show i
showValor (V2 b) = show b
showValor (V3 s) = show s

notValor :: Valor -> Valor
notValor (V2 b)   | b == True    = V2 False
                  | otherwise    = V2 True

minusValor :: Valor -> Valor
minusValor (V1 i) = V1 -i

lenValor :: Valor -> Valor
lenValor (V3 s) = V1 (length s)

length :: String -> Int
length [] = 0
length (a:as) = 1 + length as

sumValor :: Valor -> Valor -> Valor
sumValor (V1 a) (V1 b) = V1 (a + b)

subValor :: Valor -> Valor -> Valor
subValor (V1 a) (V1 b) = V1 (a - b)

andValor :: Valor -> Valor -> Valor
andValor (V2 a) (V2 b) = V2 (a && b)

orValor :: Valor -> Valor -> Valor
orValor (V2 a) (V2 b) = V2 (a || b)

igualValor :: Valor -> Valor -> Valor
igualValor (V1 a) (V1 b) = V1 (a == b)
igualValor (V3 a) (V3 b) = V3 (a == b)

concValor :: Valor -> Valor -> Valor
concValor (V3 a) (V3 b) = V3 (a & b)

--FALTA O showId

















