type Address = Int

type Enviroment = (Memory, Binding)

type Binding = [Bind]
type Memory = [Cell]

type Bind = (Address, Id)
type Cell = (Address, Valor)

getNextPos :: Memory -> Int
getNextPos [] = 0
getNextPos (a:tail) = 1 + getNextPos tail

addBind :: Binding -> Address -> Id -> Binding
addBind ([]) (ad) (id) | (ad >= 0) = [(ad, id)]
                       | otherwise = []
addBind (a:tail) (ad) (id) | (ad < 0) = (a:tail)
addBind ((a, i):tail) (ad) (id) | (ad == a)     = (a, id):tail
                                | otherwise     = (a, i):(addBind tail ad id)

addCell :: Memory -> Address -> Valor -> Memory
addCell ([]) (ad) (val) | (ad >= 0) = [(ad, val)]   -- se a cauda acabou adiciona a nova celula
                        | otherwise = []
addCell (a:tail) (ad) (val) | (ad < 0) = (a:tail)
addCell ((a, v):tail) (ad) (val) | (ad == a)     = (a, val):tail     --sobreescrever um endereco ja existente
                                 | otherwise     = (a, v):(addCell tail ad val)  --verifica a proxima celula


getBind :: Binding -> Id -> Address
getBind [] _ = -1
getBind [(a, i):tail] id | i == id      = a
                         | otherwise    = getBind tail id

--setBind :: Binding -> Address -> Id -> Binding
--setBind [] _ _ = []
--setBind (((a, i), (a, v)):tail) id val | i == id    = ((a, i), (a, val)):tail
--                                       | otherwise  = (((a, i), (a, v)):(setBind tail id val))

--removeBind :: Binding -> Address -> Memory
--removeBind [] _ = []
--removeBind (((a, i), (a, v)):tail) id | i == id     = tail
--                                      | otherwise   = (((a, i), (a, v)):(removeBind tail id))

--getAddress :: Memory -> Id -> Address
--getAddress [] _ = -1
--getAddress (((a, i), l):tail) id | i == id      = a
--                                 | otherwise    = getAddress tail id

getValue :: Memory -> Address -> Valor
getValue [] _ = V3 "Voce colocou algo na Memoria, por acaso?! _"
getValue ((a, v):tail) ad | a == ad          = v
                          | otherwise        = getValue tail ad

showBind :: Bind -> String
showBind (ad, id) = "( " ++ (show ad) ++ "," ++ (show id) ++ ")"

printBindings :: Binding -> String
printBindings ([]) = show "."
printBindings (a:tail) = (showBind a) ++ " , " ++ (printBindings tail)

showCell :: Cell -> String
showCell (ad, val) = "( " ++ (show ad) ++ "," ++ (show val) ++ ")"

printMemory :: Memory -> String
printMemory ([]) = show "."
printMemory (a:tail) = (showCell a) ++ " , " ++ (printMemory tail)
