data Programa = PROG Comando

data Comando = ATRIB Id Expressao
               | DECL Declaracao Comando
               | WHILE Expressao Comando
               | IF_THEN_ELSE Expressao Comando Comando
               | IO Io
               | SEQ_COMM Comando Comando
               | SKIP sk
               | PROC Id ListaExpressao
               deriving Show

type sk = "skip"

data Expressao = VAL Valor

               -- ExpUnaria
               | MINUS Expressao
               | NOT Expressao
               | LENGTH Expressao

               -- ExpBinaria
               | SOMA Expressao Expressao
               | SUBTRACAO Expressao Expressao
               | AND Expressao Expressao
               | OR Expressao Expressao
               | IGUAL Expressao Expressao
               | CONCATENA Expressao Expressao

               | IDENT Id
               | END_PONT Id
               deriving Show

data Declaracao = VAR_IGUAL Id Expressao
                | PONTEIRO Id Tipo
                | DECL_PROC DeclaracaoProc
                | VIRG Declaracao Declaracao
                deriving Show

data DeclaracaoProc = PROC_PAR Id ListaDeclaracaoParametro Comando
                    | PROC_VOID Id Comando
                    deriving Show

data ListaDeclaracaoParametro = SINGLE_DECL Tipo Id
                              | LIST_DECL Tipo Id ListaDeclaracaoParametro
                              deriving Show

data Tipo = TString
          | TInt
          | TBool
          deriving Show

data IO = WRITE Expressao
        | READ Id
        deriving Show

data ListaExpressao = FINAL Expressao
                    | LIST_EXP Expressao ListaExpressao
                    deriving Show

type Id = String
        deriving Show

data Valor = V1 Int 
           | V2 Bool 
           | V3 String
           | PROCED DeclaracaoProc
           | Nil
           deriving Show

-- AQUI COMEA OS EVAL
--interprete :: Programa -> Input -> String
--interprete (PROG prog) (i) = printMemory (evalComando (prog) memory)

evalExpressao :: Expressao -> Memory -> Valor
evalExpressao (V1 i) _ = V1 i
evalExpressao (V2 b) _ = V2 b
evalExpressao (V3 s) _ = V3 s

evalExpressao (NOT e) mem = V2 (not (evalExpressao e mem))
evalExpressao (MINUS e) mem = V1 (-(evalExpressao e mem))
evalExpressao (LENGTH e) mem = V1 (length(evalExpressao e mem))

evalExpressao (SOMA e1 e2) mem = V1 ((evalExpressao e1 mem) + (evalExpressao e2 mem))
evalExpressao (SUBTRACAO e1 e2) mem = V1 ((evalExpressao e1 mem) - (evalExpressao e2 mem))
evalExpressao (AND e1 e2) mem = V2 ((evalExpressao e1 mem) && (evalExpressao e2 mem))
evalExpressao (OR e1 e2) mem = V2 ((evalExpressao e1 mem) || (evalExpressao e2 mem))
evalExpressao (IGUAL e1 e2) mem = V2 ((evalExpressao e1 mem) == (evalExpressao e2 mem))
evalExpressao (CONCATENA e1 e2) mem = V3 ((evalExpressao e1 mem) ++ (evalExpressao e2 mem))

evalExpressao (IDENT i) mem = getBind mem i
-- r := &v
evalExpressao (END_PONT i) mem = V1 (getAddress mem i)

evalComando :: Comando -> Memoria -> Memoria
evalComando (ATRIB ident expr) (mem) = evalAtribuicao (showId ident) (eval expr) (mem)
evalComando (DECL decl comm) (mem) = evalDeclaracao (eval decl) (evalComando comm) (mem)
evalComando (WHILE expr comm) (mem) = evalWhile (eval expr) (eval comm) (mem)
evalComando (IF_THEN_ELSE expr comm1 comm2) (mem) = evalIfThenElse (eval expr) (eval comm1) (eval comm2) (mem)
evalComando (IO entrada) (mem) = evalIO (eval entrada) (mem)
evalComando (SEQ_COMM comm1 comm2) (mem) = evalSeqComm (comm1) (comm2) (mem)
evalComando (SKIP sk) (mem) = evalSkip (showId sk) (mem)
evalComando (PROC ident lista) (mem) = evalProcedure (showId ident) (eval lista) (mem)

evalSeqComm :: Comando -> Comando -> Memoria -> Memoria
evalSeqComm c1 c2 mem = evalComando c2 (evalComando c1 mem)

evalDeclaracao :: Declaracao -> Comando -> Memoria -> Memoria
evalDeclaracao (VAR_IGUAL i exp) comm mem = eval  exp evalComando comm mem
evalDeclaracao (PONTEIRO a) =
evalDeclaracao (PROC_VOID a) =
evalDeclaracao (VIRG a) =

evalWhile :: Expressao -> Comando ->
evalWhile (expr comm) = (eval expr) h...



eval :: ListaExpressao -> [Valor]
eval (FINAL exp) = eval exp : []
eval (LIST_EXP exp lista) = eval exp : eval (lista)

showValor :: Valor -> String
showValor (V1 i) = show i
showValor (V2 b) = show b
showValor (V3 s) = show s

notValor :: Valor -> Valor
notValor (V2 b)   | b == True    = V2 False
                  | otherwise    = V2 True

minusValor :: Valor -> Valor
minusValor (V1 i) = V1 -i

lenValor :: Valor -> Valor
lenValor (V3 s) = V1 (length s)

sumValor :: Valor -> Valor -> Valor
sumValor (V1 a) (V1 b) = V1 (a + b)

subValor :: Valor -> Valor -> Valor
subValor (V1 a) (V1 b) = V1 (a - b)

andValor :: Valor -> Valor -> Valor
andValor (V2 a) (V2 b) = V2 (a && b)

orValor :: Valor -> Valor -> Valor
orValor (V2 a) (V2 b) = V2 (a || b)

igualValor :: Valor -> Valor -> Valor
igualValor (V1 a) (V1 b) = V2 (a == b)
igualValor (V3 a) (V3 b) = V2 (a == b)

concValor :: Valor -> Valor -> Valor
concValor (V3 a) (V3 b) = V3 (a ++ b)

--FALTA O showId

















